include "basics/pts.ma".
include "connectives.ma".
include "leibniz.ma".
include "logic.ma".
include "relations.ma".
axiom nat : Type[0].
axiom O : nat.
axiom S : nat -> nat.
axiom match_nat_type : \forall return_ : Type[0] . return_ -> (nat -> return_) -> nat -> return_.
axiom axiom_match_nat_type_S : \forall return_type. \forall (case_O:return_type). \forall (case_S:nat -> return_type). \forall (n:nat). (equal) (return_type) ((match_nat_type) (return_type) case_O case_S ((S)  n)) (case_S n).
definition eq_match_nat_type_S : \forall return_type. \forall (case_O:return_type). \forall (case_S:nat -> return_type). \forall (n:nat). (leibniz) (return_type) ((match_nat_type) (return_type) case_O case_S ((S)  n)) (case_S n) := \lambda return_type : Type[0]. \lambda case_O : return_type. \lambda case_S : nat -> return_type. \lambda n : nat. ((((equal_leibniz) (return_type)) ((match_nat_type) (return_type) case_O case_S ((S)  n))) (case_S n)) (((((axiom_match_nat_type_S) (return_type)) (case_O)) (case_S)) (n)).
definition sym_eq_match_nat_type_S : \forall return_type. \forall (case_O:return_type). \forall (case_S:nat -> return_type). \forall (n:nat). (leibniz) (return_type) (case_S n) ((match_nat_type) (return_type) case_O case_S ((S)  n)) := \lambda return_type : Type[0]. \lambda case_O : return_type. \lambda case_S : nat -> return_type. \lambda n : nat. ((((sym_leibniz) (return_type)) ((match_nat_type) (return_type) case_O case_S ((S)  n))) (case_S n)) (((((eq_match_nat_type_S) (return_type)) (case_O)) (case_S)) (n)).
definition pred : nat -> nat := \lambda n : nat. (match_nat_type) (nat) (O)  (\lambda p : nat. p) n.
definition pred_Sn : \forall (n:nat). (eq) (nat) n ((pred)  ((S)  n)) := \lambda n : nat. ((((((sym_eq_match_nat_type_S) (nat)) ((O) )) (\lambda p : nat. p)) (n)) (\lambda y : nat. (eq) (nat) n y)) (((refl) (nat)) (n)).
definition injective_S : (injective) (nat) (nat) (S)  := \lambda x : nat. \lambda y : nat. \lambda auto : (eq) (nat) ((S)  x) ((S)  y). (((((((rewrite_l) (nat)) (y)) (\lambda j__ : nat. (eq) (nat) j__ y)) (((refl) (nat)) (y))) (x)) (((((((rewrite_r) (nat)) ((pred)  ((S)  x))) (\lambda j__ : nat. (eq) (nat) y j__)) (((((((rewrite_r) (nat)) ((S)  y)) (\lambda j__ : nat. (eq) (nat) y ((pred)  j__))) ((pred_Sn) (y))) ((S)  x)) (auto))) (x)) ((pred_Sn) (x)))).
